<?php
/**
 * translateHepler
 *
 * @version 1.0.0
 * @package translateHepler
 * @author ZyX (Micriucov Oleg)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.ru
 **/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  plgSystemTranslateHelper extends JPlugin{

	function __construct(& $subject, $params){
		parent::__construct($subject, $params);
	}
	
	function onAfterInitialise(){
		$user = JFactory::getUser();
		$this->JVersion = substr(JVERSION,0,3);
		if($this->JVersion=='1.7'||$this->JVersion=='2.5') $this->JVersion = '1.6';
		$this->addUrl = '';
		$this->addPath = '';
		if($this->JVersion=='1.6'){
			$this->addUrl = 'translateHelper/';
			$this->addPath = 'translateHelper'.DS;
		}
		if(is_file(JPATH_ROOT.DS.'plugins'.DS.'system'.DS.'translateHelper'.DS.$this->addPath.'language_'.$this->JVersion.'.php')) include_once(JPATH_ROOT.DS.'plugins'.DS.'system'.DS.'translateHelper'.DS.$this->addPath.'language_'.$this->JVersion.'.php');
		else return false;
		$lang = &JFactory::getLanguage();
		$conf	= JFactory::getConfig();
		$locale	= $this->JVersion=='1.5'?$conf->getValue('config.language'):$conf->get('language');
		$debug	= $this->JVersion=='1.5'?$conf->getValue('config.debug_lang'):$conf->get('debug_lang');
		$lang = new ZLanguage($locale,$debug);
		if($this->JVersion=='1.6') JFactory::$language = &$lang;
		$doc = &JFactory::getDocument();
		$doc->addScript(JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets/js/jquery-1.5.min.js');
		$doc->addScript(JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets/js/jquery-ui.min.js');
		$doc->addScript(JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets/js/scripts.js');
		$doc->addStyleSheet(JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets/styles.css');
		$doc->addScriptDeclaration('JURIroot = "'.JURI::root().'";JURIbase = "'.JURI::base().'";URL2Assets = "'.JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets";');
		$zTask = JRequest::getCmd('zTask','');
		if($zTask=='editWord'){
			$this->processEditWord();
		}
		else if($zTask=='saveWord'){
			$this->processSaveWord();
		}
	}
	
	function onAfterRender(){
		$body = JResponse::getBody();
		if($body=='') return;
		$objs = array();
		$this->processBodyHTML($body,$objs);
		if(count($objs)){
			$html = '<div id="translateHelperInfo"><img onclick="cancelEditWord(this.parentNode);return false;" class="zCloseImg" src="'.JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets/images/icon_delete.gif" title="close" />';
			$html.= '<h3 class="hasTip" title="Texts found in scripts, titles, alt\'s and others tag parameters">Hidden texts</h3>';
			$zLang = JFactory::getLanguage();
			foreach($objs as $obj){
				if($obj->ext&&$obj->ext!='joomla'){
					$zLang->load($obj->ext,JPATH_BASE);
				}
				$html.= '<div><span class="translateHelperInfoElem"><img onclick="callEditWord(this.parentNode,\''.$obj->file.'\',\''.$obj->zkey.'\',\''.$obj->ext.'\');return false;" title="Edit" src="'.JURI::root().'plugins/system/translateHelper/'.$this->addUrl.'assets/images/comment_edit.png" /></span>'.(isset($zLang->strings[$obj->zkey])?$zLang->strings[$obj->zkey]:$obj->zkey).'</div>';
			}
			$html.= '</div>';
			$body = str_replace('</body>',$html.'</body>',$body);
		}
		JResponse::setBody($body);
	}
		
	function processBodyHTML(&$body,&$objs){
		$keys = array();
		$replaces = array(
			'\\'	=>	'\\\\',
			'/'		=>	'\\/',
			'.'		=>	'\.',
			'"'		=>	'\\"'
		);
		preg_match_all('~&lt;br class=&quot;translateHelperWord(.*?)(?=&gt;)~i',$body,$regs);
		foreach((array)$regs[1] as $line){
			preg_match_all('/([a-z]+=&quot;[^&]+)/is',$line,$paramsReg);
			$obj = new stdclass;
			$obj->place = 'head';
			foreach((array)$paramsReg[1] as $paramReg){
				$paramReg = str_replace('&quot;','',$paramReg);
				$paramReg = explode('=',$paramReg);
				$obj->$paramReg[0] = trim($paramReg[1]);
			}
			if(!in_array($obj->zkey,$keys)){
				$objs[] = $obj;
				$keys[] = $obj->zkey;
			}
			$line = str_replace(array_keys($replaces),array_values($replaces),$line);
			$body = preg_replace('~&lt;br class=&quot;translateHelperWord'.$line.'&gt;~is','',$body);
		}
		preg_match_all('/<br-class="translateHelperWord([^>]+)/si',$body,$regs);
		foreach((array)$regs[1] as $line){
			preg_match_all('/([a-z]+="[^"]+)/i',$line,$paramsReg);
			$obj = new stdclass;
			$obj->place = 'body';
			foreach((array)$paramsReg[1] as $paramReg){
				$paramReg = str_replace('"','',$paramReg);
				$paramReg = explode('=',$paramReg);
				$obj->$paramReg[0] = trim($paramReg[1]);
			}
			if(!in_array($obj->zkey,$keys)){
				$objs[] = $obj;
				$keys[] = $obj->zkey;
			}
			$line = str_replace(array_keys($replaces),array_values($replaces),$line);
			$body = preg_replace('/<br-class="translateHelperWord'.$line.'>/is','',$body);
		}
		for($i=0;$i<5;$i++){
			preg_match_all('/(<[^>]+)<br class=([\\\\"]+)translateHelperWord([^>]+)/si',$body,$regs);
			foreach((array)$regs[3] as $rkey=>$line){
				preg_match_all('/([a-z]+)=[\\\\"]+([^"]+)/i',$line,$paramsReg);
				$obj = new stdclass;
				$obj->place = 'params';
				foreach((array)$paramsReg[1] as $pkey=>$paramReg){
					$kk = trim($paramReg);
					$vv = trim($paramsReg[2][$pkey]);
					if(substr($vv,-1,1)=='\\') $vv = substr($vv,0,-1);
					$obj->$kk = $vv;
				}
				if(!in_array($obj->zkey,$keys)){
					$objs[] = $obj;
					$keys[] = $obj->zkey;
				}
				$line = str_replace(array_keys($replaces),array_values($replaces),$line);
				$body = preg_replace('/<br class='.str_replace(array_keys($replaces),array_values($replaces),$regs[2][$rkey]).'translateHelperWord'.$line.'>/is','',$body);
			}
		}
		preg_match_all('/<script[^>]+>\s+(.*?)(?=<\/script>)/siu',$body,$regs);
		foreach((array)$regs[1] as $script){
			preg_match_all('/<br class="translateHelperWord([^>]+)/si',$script,$regs);
			foreach((array)$regs[1] as $line){
				preg_match_all('/([a-z]+)="([^"]+)/i',$line,$paramsReg);
				$obj = new stdclass;
				$obj->place = 'script';
				foreach((array)$paramsReg[1] as $pkey=>$paramReg){
					$kk = trim($paramReg);
					$vv = trim($paramsReg[2][$pkey]);
					if(substr($vv,-1,1)=='\\') $vv = substr($vv,0,-1);
					$obj->$kk = $vv;
				}
				if(!in_array($obj->zkey,$keys)){
					$objs[] = $obj;
					$keys[] = $obj->zkey;
				}
				$line = str_replace(array_keys($replaces),array_values($replaces),$line);
				$body = preg_replace('/<br class="translateHelperWord'.$line.'>/is','',$body);
			}
		}
	}
	
	function processSaveWord(){
		header('Content-type: text/html; charset="utf-8"',true);
		$key = JRequest::getVar('key','');
		$key = JString::strtoupper($key);
		$ext = JRequest::getVar('ext','');
		$file = JRequest::getVar('file','');
		$newWord = JRequest::getVar('newWord','');
		if(!($key!=''&&$file!=''&&is_file($file))) $this->close('!Text or file ('.$file.') not found.');
		if(!is_writable($file)) $this->close('!File ('.$file.') is not writable.');
		$content = file_get_contents($file);
		if($this->JVersion=='1.5'){
			$replaces = array(
				'"'	=>	'"'
			);
		}
		else{
			$replaces = array(
				'"'	=>	'"_QQ_"'
			);
		}
		$word = htmlentities($newWord,ENT_NOQUOTES,'utf-8');
		$word = str_replace(array_keys($replaces),array_values($replaces),$word);
		$content = preg_replace('~'.$key.'\s?=[^\n$]+~iu',$key.'="'.$word.'"',$content);
		$result = file_put_contents($file,$content);
		if($result>0) $this->close($newWord);
		else $this->close('!Error writing to file ('.$file.').');
	}
	
	function processEditWord(){
		header('Content-type: text/html; charset="utf-8"',true);
		$zLang = JFactory::getLanguage();
		$key = JRequest::getVar('key','');
		$key = JString::strtoupper($key);
		$ext = JRequest::getVar('ext','');
		$file = JRequest::getVar('file','');
		if($ext&&$ext!='joomla'){
			$zLang->load($ext,JPATH_BASE);
		}
		$word = $zLang->getZString($key);
		if(JString::strlen($word)>50){
			$word = htmlentities($word,ENT_COMPAT,'utf-8');
			$input = '<textarea onclick="return false;" name="newWord">'.$word.'</textarea>';
		}
		else if(JString::strlen($word)>0){
			$word = htmlentities($word,ENT_COMPAT,'utf-8');
			$input = '<input onclick="return false;" type="text" class="inputtext" name="newWord" value="'.$word.'" />';
		}
		else{
			$this->close('!x!');
		}
		?>
		<div class="translateHelperWordEdit">
			<img onclick="cancelEditWord(this.parentNode.parentNode);return false;" class="zCloseImg" src="<?php echo JURI::root();?>plugins/system/translateHelper/<?php echo $this->addUrl;?>assets/images/icon_cancel.gif" title="cancel" />
			<img onclick="saveZWord(this);return false;" class="zSaveImg" src="<?php echo JURI::root();?>plugins/system/translateHelper/<?php echo $this->addUrl;?>assets/images/icon_apply.gif" title="save" />
			<strong><?php echo $key;?></strong><span><?php echo $file;?></span>
			<form>
			<input type="hidden" name="zTask" value="saveWord" />
			<input type="hidden" name="key" value="<?php echo $key;?>" />
			<input type="hidden" name="ext" value="<?php echo $ext;?>" />
			<input type="hidden" name="file" value="<?php echo $file;?>" />
			<?php echo $input;?>
			</form>
		</div>
		<?php
		$this->close();
	}
	
	function close($msg=''){
		if($msg!='') echo $msg;
		if($this->JVersion=='1.5') $GLOBALS['mainframe']->close();
		else $GLOBALS['app']->close();
	}
	
}