<?php
defined('JPATH_BASE') or die;

class ZLanguage extends JLanguage{
	var $_debug 	= false;
	var $_default	= 'en-GB';
	var $_orphans 	= array();
	var $_metadata 	= null;
	var $_lang = null;
	var $_paths	= array();
	var $_strings = null;
	var $_used		= array();
	var $keys2files = array();
	var $keys2exts = array();
	
	function __construct($lang = null){
		parent::__construct($lang);
	}
	
	function &getInstance($lang){
		$instance = new ZLanguage($lang);
		$reference = & $instance;
		return $reference;
	}
	
	function getZString($key){
		if(isset($this->_strings[$key])) $word = $this->_strings[$key];
		else $word = '';
		return $word;
	}

	function _($string, $jsSafe = false){
		$key = strtoupper($string);
		$key = substr($key, 0, 1) == '_' ? substr($key, 1) : $key;
		if(isset($this->_strings[$key])) $string = $this->_strings[$key];
		else if(defined($string)) $string = constant($string);
		if($jsSafe) $string = addslashes($string);
		if(/*!$jsSafe&&*/isset($this->_strings[$key])&&isset($this->keys2files[$key])){
			$file = $this->keys2files[$key];
			$ext = $this->keys2exts[$key];
			$string = '<br class="translateHelperWord" file="'.$file.'" zkey="'.$key.'" ext="'.$ext.'" />'.$string;
		}
		return $string;
	}
	
	function _load( $filename, $extension = 'unknown', $overwrite = true ){
		$result	= false;
		if ($content = @file_get_contents( $filename )){
			if ( $content[0] == "\xEF" && $content[1] == "\xBB" && $content[2] == "\xBF" ){
				$content = substr( $content, 3 );
		  	}
			$registry	= new JRegistry();
			$registry->loadINI($content);
			$newStrings	= $registry->toArray();
			if (is_array( $newStrings)){
				$this->_strings = $overwrite ? array_merge( $this->_strings, $newStrings) : array_merge( $newStrings, $this->_strings);
				$result = true;
				foreach($newStrings as $strKey=>$strVal){
					$filename = str_replace('\\','/',$filename);
					$this->keys2files[$strKey] = $filename;
					$this->keys2exts[$strKey] = $extension;
				}
			}
		}
		if ( ! isset($this->_paths[$extension])) {
			$this->_paths[$extension] = array();
		}
		$this->_paths[$extension][$filename] = $result;
		return $result;
	}
	
}

