<?php
defined('JPATH_BASE') or die;

class ZLanguage extends JLanguage{

	protected static $languages = array();
	protected $debug = false;
	protected $default	= 'en-GB';
	protected $orphans = array();
	protected $metadata = null;
	protected $locale = null;
	protected $lang = null;
	protected $paths = array();
	protected $errorfiles = array();
	public $strings = null;
	protected $used = array();
	protected $counter = 0;
	protected $override = array();
	protected $transliterator = null;
	protected $pluralSufficesCallback = null;
	protected $ignoredSearchWordsCallback = null;
	protected $lowerLimitSearchWordCallback = null;
	protected $upperLimitSearchWordCallback = null;
	protected $searchDisplayedCharactersNumberCallback = null;
	protected $keys2files = array();
	protected $keys2exts = array();
	
	public function __construct($lang = null, $debug = false){
		parent::__construct($lang,$debug);
	}

	public function getZString($key){
		if(isset($this->strings[$key])) $word = $this->strings[$key];
		else $word = '';
		return $word;
	}
	
	public function _($string, $jsSafe = false, $interpreteBackSlashes = true){
		$key = strtoupper($string);
		if(isset($this->strings[$key])) {
			$string = $this->strings[$key];
		}
		if ($jsSafe) {
			$string = addslashes($string);
		}
		elseif ($interpreteBackSlashes) {
			$string = str_replace(array('\\\\','\t','\n'),array("\\", "\t","\n"),$string);
		}
		if(!$jsSafe&&isset($this->strings[$key])&&isset($this->keys2files[$key])){
			$file = $this->keys2files[$key];
			$ext = $this->keys2exts[$key];
			$string = '<br class="translateHelperWord" file="'.$file.'" zkey="'.$key.'" ext="'.$ext.'" />'.$string;
		}

		return $string;
	}
	
	protected function loadLanguage($filename, $extension = 'unknown', $overwrite = true){
		$this->counter++;

		$result	= false;
		$strings = false;
		if (file_exists($filename)) {
			$strings = $this->parse($filename);
		}

		if ($strings) {
			if (is_array($strings)) {
				foreach($strings as $strKey=>$strVal){
					$filename = str_replace('\\','/',$filename);
					$this->keys2files[$strKey] = $filename;
					$this->keys2exts[$strKey] = $extension;
				}
				$this->strings = array_merge($this->strings, $strings);
			}
			if (is_array($strings) && count($strings)) {
				$this->strings = array_merge($this->strings, $this->override);
				$result = true;
			}
		}

		if (! isset($this->paths[$extension])) {
			$this->paths[$extension] = array();
		}

		$this->paths[$extension][$filename] = $result;

		return $result;
	}
}

